#include <LiquidCrystal.h>
#include <MsTimer2.h> // https://github.com/PaulStoffregen/MsTimer2
LiquidCrystal lcd(7, 8, 9, 10, 11, 12);// RS,E,D4,D5,D6,D7
unsigned long time0;
byte korr_time,korr,korr_rele,s,m,h,i,z,h0,m0,pause,value[16];
/// переменные для пяти реле (время выключения, часы и минуты)
byte m_1_off,h_1_off;
byte m_2_off,h_2_off;
byte m_3_off,h_3_off;
byte m_4_off,h_4_off;
byte m_5_off,h_5_off;
int kn,kn1,kn2;
void setup()
{ 
  lcd.begin(16, 2);// LCD 16X2
  MsTimer2::set(1000, to_Timer);// задаем период 1с
  MsTimer2::start();// старт таймера
  Serial.begin(9600);
  pinMode(A3,INPUT);// кнопка К
  pinMode(A4,INPUT);// кнопка +
  pinMode(A5,INPUT);// кнопка -
  
  pinMode(6,OUTPUT); //Реле1
  pinMode(5,OUTPUT); //Реле2
  pinMode(4,OUTPUT); //Реле3
  pinMode(3,OUTPUT); //Реле4
  pinMode(2,OUTPUT); //Реле5
}
void to_Timer(){ if(korr_time==0){s++;}else{s=0;} /// ОТСЧЕТ ВРЕМЕНИ ЧАСОВ ///////
  if(s > 59){s = 0;m++;} // отсчет 1 мин
  if(m > 59){m = 0;h++;} // отсчет 1 час
  if(h > 23){h = 0;}} 
void korr_Time(){  kn=analogRead(A3); kn1=analogRead(A4); kn2=analogRead(A5);
  // ВКЛЮЧЕНИЕ КОРРЕКЦИИ ВРЕМЕНИ = НАЖАТЬ ОДНОВРЕМЕННО КНОПКИ + И -
  if(kn1>600 && kn2>600){korr_time=1;korr=1;}
  if(kn>600 && korr_time==1 && korr<=2){korr++;if(korr>=3){korr=0;korr_time=0;pause=s+1;if(s<pause){kn=0;}}}
  /// КОРРЕКЦИЯ ВРЕМЕНИ ЧАСОВ /////////
  if(kn1>600 && korr==1){m++;}
  if(kn1>600 && korr==2){h++;}
  if(kn2>600 && korr==1){m--;if(m>60){m=0;}}
  if(kn2>600 && korr==2){h--;}}

void loop(){
korr_Time();

/// УСТАНОВКА ВРЕМЕНИ СРАБАТЫВАНИЯ РЕЛЕ ////////////////////////////
  if(korr_time==0){ 
  if(kn>600){korr_rele++;if(korr_rele>=11){korr_rele=0;}}
 // m0 и h0 переменные для редактирования
  if(korr_rele>=1 && korr_rele<=2){m0=m_1_off;h0=h_1_off;}
  if(korr_rele>=3 && korr_rele<=4){m0=m_2_off;h0=h_2_off;}
  if(korr_rele>=5 && korr_rele<=6){m0=m_3_off;h0=h_3_off;}
  if(korr_rele>=7 && korr_rele<=8){m0=m_4_off;h0=h_4_off;}
  if(korr_rele>=9 && korr_rele<=10){m0=m_5_off;h0=h_5_off;}
  
/// КОРРЕКЦИЯ ВРЕМЕНИ РЕЛЕ /////////
  if(kn1>600 && (korr_rele==1 || korr_rele==3 || korr_rele==5 || korr_rele==7 || korr_rele==9)){m0++;if(m0>59){m0=0;}}
  if(kn1>600 && (korr_rele==2 || korr_rele==4 || korr_rele==6 || korr_rele==8 || korr_rele==10)){h0++;if(h0>23){h0=0;}}
  if(kn2>600 && (korr_rele==1 || korr_rele==3 || korr_rele==5 || korr_rele==7 || korr_rele==9)){m0--;if(m0>60){m0=0;}}
  if(kn2>600 && (korr_rele==2 || korr_rele==4 || korr_rele==6 || korr_rele==8 || korr_rele==10)){h0--;if(h0>24){h0=0;}}
  }

  // вывод информации на экран 1 строка
  lcd.setCursor(1,0);
  if(korr==2 && i==1){lcd.print("  ");}else{ 
  if(h < 10){lcd.print("0");}
  lcd.print(h);} // часы
  lcd.print(":");
  if(korr==1 && i==1){lcd.print("  ");}else{
  if(m < 10 ){lcd.print("0");}
  lcd.print(m);} // минуты
  lcd.print(":");
  if(s < 10){lcd.print("0");}
  lcd.print(s);// секунды
  if(korr==0){lcd.print(" TIME");}
  
   // вывод информации на экран 2 строка
  lcd.setCursor(1,1); 
  if(korr_rele>=1 && korr_rele<=2){lcd.print("1 ");}
  if(korr_rele>=3 && korr_rele<=4){lcd.print("2 ");}
  if(korr_rele>=5 && korr_rele<=6){lcd.print("3 ");}
  if(korr_rele>=7 && korr_rele<=8){lcd.print("4 ");}
  if(korr_rele>=9 && korr_rele<=10){lcd.print("5 ");}
  
  if(korr_rele==0) {  // опрос сотояния выходов
  if(digitalRead(6)==HIGH){lcd.print("1 ");}else{lcd.print("0 ");}
  if(digitalRead(5)==HIGH){lcd.print("1 ");}else{lcd.print("0 ");}
  if(digitalRead(4)==HIGH){lcd.print("1 ");}else{lcd.print("0 ");}
  if(digitalRead(3)==HIGH){lcd.print("1 ");}else{lcd.print("0 ");}
  if(digitalRead(2)==HIGH){lcd.print("1 ");}else{lcd.print("0 ");}
  }
  
  if(korr_rele>0){ z=0;
  if((korr_rele==2 || korr_rele==4 || korr_rele==6 || korr_rele==8 || korr_rele==10) && i==1){lcd.print("  ");}else{ 
  if(h0 < 10){lcd.print("0");}
  lcd.print(h0);} // часы
  lcd.print(":");
  if((korr_rele==1 || korr_rele==3 || korr_rele==5 || korr_rele==7 || korr_rele==9) && i==1){lcd.print("  ");}else{ 
  if(m0 < 10 ){lcd.print("0");}
  lcd.print(m0);} // минуты
  }
  
  if(korr_rele>=1 && korr_rele<=2){m_1_off= m0;h_1_off=h0;}
  if(korr_rele>=3 && korr_rele<=4){m_2_off= m0;h_2_off=h0;}
  if(korr_rele>=5 && korr_rele<=6){m_3_off= m0;h_3_off=h0;}
  if(korr_rele>=7 && korr_rele<=8){m_4_off= m0;h_4_off=h0;}
  if(korr_rele>=9 && korr_rele<=10){m_5_off= m0;h_5_off=h0;}
  
  // срабатывание реле по времени
  if((h*60+m)>= 0 && (h*60+m)<(h_1_off*60+m_1_off)){digitalWrite(6,HIGH);}
  if((h*60+m)>=(h_1_off*60+m_1_off)){digitalWrite(6,LOW);}
  if((h*60+m)>= 0 && (h*60+m)<(h_2_off*60+m_2_off)){digitalWrite(5,HIGH);}
  if((h*60+m)>=(h_2_off*60+m_2_off)){digitalWrite(5,LOW);}
  if((h*60+m)>= 0 && (h*60+m)<(h_3_off*60+m_3_off)){digitalWrite(4,HIGH);}
  if((h*60+m)>=(h_3_off*60+m_3_off)){digitalWrite(4,LOW);}
  if((h*60+m)>= 0 && (h*60+m)<(h_4_off*60+m_4_off)){digitalWrite(3,HIGH);}
  if((h*60+m)>=(h_4_off*60+m_4_off)){digitalWrite(3,LOW);}
  if((h*60+m)>= 0 && (h*60+m)<(h_5_off*60+m_5_off)){digitalWrite(2,HIGH);}
  if((h*60+m)>=(h_5_off*60+m_5_off)){digitalWrite(2,LOW);}

  i++;if(i==3){i=0;}
  delay(200);
  
  lcd.clear();
}
